import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import graphs.JSuperSlider;
import java.net.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;

public class Plota extends JApplet implements Runnable
{
    private Thread m_Runner;
    private int m_pszX;
    private int m_pszY;
    private boolean m_bInvalid;
    private javax.swing.JPanel m_Board;
    private PanelA m_PanelA;
    private final int NUMPOINTS = 1000;
    public int m_NumPoints;

    //public double m_X[];
    //public double m_Y[];
    public Vector m_Xs;
    public Vector m_Ys;

    private final double start_value = 0.001491; // pick something unique that's not likely to be an actual value
    //private final double tolerance = 0.00001;    // used for comparing double values
    public double m_Xmin_orig=start_value;
    public double m_Xmax_orig=start_value;
    public double m_Ymin_orig=start_value;
    public double m_Ymax_orig=start_value;
    public double m_Xmin=start_value;
    public double m_Xmax=start_value;
    public double m_Ymin=start_value;
    public double m_Ymax=start_value;
    public int eqNum;
    public String yAxisImgName="";
    public String xAxisImgName="";
    public Image xAxisImg,yAxisImg;
    public String m_strMessage;
    protected JSuperSlider[] jSlider = new JSuperSlider[6];
    String[] params = new String[6];
    Hashtable[] labelTable = new Hashtable[6];
    javax.swing.JPanel jPanel, innerPanel;

    public void init()
    {
        eqNum = -1;
        try {
            eqNum = Integer.parseInt(getParameter("eqNum"));
        } catch(Exception e){
            e.printStackTrace();
        }
        resize(m_pszX, m_pszY);
        setBackground(Color.blue);
        this.getContentPane().setLayout(new BorderLayout());
        m_Board = new javax.swing.JPanel();
        m_PanelA = new PanelA(this);
        jPanel = new javax.swing.JPanel();
        m_PanelA.setBackground(Color.cyan);
	m_PanelA.addMouseListener(mListener); // to listen for mouse clicks
        m_Board.add("Center", m_PanelA);

        this.getContentPane().add("Center", m_Board);

	JPanel slidersAndLegend = new JPanel();
	/*
	slidersAndLegend.add(getOptionsPanel(), BorderLayout.WEST);
	slidersAndLegend.add(new JLabel("   "), BorderLayout.CENTER);
	javax.swing.JComponent legend = getLegend();
	if (legend != null) {
	    slidersAndLegend.add(legend, BorderLayout.EAST);
	    }*/

	GridBagLayout gridbag = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	slidersAndLegend.setLayout(gridbag);
	c.fill = GridBagConstraints.HORIZONTAL;

	javax.swing.JPanel optionsPanel = getOptionsPanel();
	c.gridx = 0; c.gridy = 0;
	c.anchor = GridBagConstraints.NORTH;
	gridbag.setConstraints(optionsPanel, c);
	slidersAndLegend.add(optionsPanel);

	JLabel blank = new JLabel("   ");
	c.gridx = 1; c.gridy = 0;
	gridbag.setConstraints(blank, c);
	slidersAndLegend.add(blank);

	javax.swing.JComponent legend = getLegend();
	if (legend != null) {
	    c.gridx = 2; c.gridy = 0;
	    c.anchor = GridBagConstraints.NORTH;
	    gridbag.setConstraints(legend, c);
	    slidersAndLegend.add(legend);
	}

        //m_Board.add(getOptionsPanel(), BorderLayout.SOUTH);
        m_Board.add(slidersAndLegend, BorderLayout.SOUTH);
	javax.swing.Timer loader = new javax.swing.Timer(1, new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent evt) {
		    SetParam((double)jSlider[0].getValue()/1000,(double)jSlider[1].getValue()/1000,(double)jSlider[2].getValue()/1000,(double)jSlider[3].getValue()/1000,(double)jSlider[4].getValue()/1000,(double)jSlider[5].getValue()/1000);
		}    
	    });
	loader.setRepeats(false);
	loader.setCoalesce(true);
	loader.start();        
    }

    public void start()
    {
        if(m_Runner == null)
        {
            m_Runner = new Thread(this);
            m_Runner.start();
        }
        m_PanelA.start();
    }

    public void stop()
    {
        if(m_Runner != null)
        {
            m_Runner.stop();
            m_Runner = null;
        }
        m_PanelA.stop();
    }

    //public void getData(int n, double x[], double y[]) {
    public void getData(int n, Vector xs, Vector ys) {
        m_NumPoints = n;
	
	if (!fromZoom) {
	    // set the hard min & max if this is the first time through

	    System.out.println("Setting hard min & max on the first time through");

	    m_Xmin = m_Xmax = ( (double[])xs.elementAt(0) )[0];
	    m_Ymin = m_Ymax = ( (double[])ys.elementAt(0) )[0];

	    System.out.println("There are a total of [" + xs.size() + "] graphs to look at.");
	    for (int graphnum = 0; graphnum < xs.size(); graphnum++) {
		System.out.println("Looking at graphnum #" + graphnum);
		double x[] = (double[])xs.elementAt(graphnum);
		double y[] = (double[])ys.elementAt(graphnum);

		for (int i = 0; i < m_NumPoints; i++) {
		    //m_X[i] = x[i];
		    //m_Y[i] = y[i];

		    if (x==null) { System.out.println("X WAS NULL"); };

		    if(x[i] < m_Xmin)
			m_Xmin = x[i];
		    if(x[i] > m_Xmax)
			m_Xmax = x[i];
		    if(y[i] < m_Ymin)
			m_Ymin = y[i];
		    if(y[i] > m_Ymax)
			m_Ymax = y[i];
		}
	    }
	}  /*else {
	    
	    // otherwise, just update the points and not the min & max

	    System.out.println("Updating points but not min & max");
*/
	    /*
	    for (int i=0; i<m_NumPoints;i++) {
		m_X[i] = x[i];
		m_Y[i] = y[i];
	    }*/

	// Copy the vectors by value
	//
	m_Xs = new Vector();
	m_Ys = new Vector();

	for (int graphnum = 0; graphnum < xs.size(); graphnum++) {
	    double x[] = (double[])xs.elementAt(graphnum);
	    double y[] = (double[])ys.elementAt(graphnum);
	    
	    double x_copy[] = new double[x.length];
	    double y_copy[] = new double[y.length];
	    
	    for (int i=0; i<m_NumPoints;i++) {
		x_copy[i] = x[i];
		y_copy[i] = y[i];
	    }
	    
	    m_Xs.add(x_copy);
	    m_Ys.add(y_copy);
	}

        m_strMessage = "Plot";
        m_PanelA.setInvalid();

	if (m_Xmin_orig == start_value) { m_Xmin_orig = m_Xmin; }; // only set this the first time
	if (m_Xmax_orig == start_value) { m_Xmax_orig = m_Xmax; };
	if (m_Ymin_orig == start_value) { m_Ymin_orig = m_Ymin; };
	if (m_Ymax_orig == start_value) { m_Ymax_orig = m_Ymax; };
    }

    public Plota()
    {
        m_pszX = 510;
        m_pszY = 310;
        m_bInvalid = true;
        m_NumPoints = 1000;
        //m_X = new double[1000];
        //m_Y = new double[1000];
	m_Xs = new Vector();
	m_Ys = new Vector();

        m_Xmax = 400D;
	m_Ymax = 200D;
        m_strMessage = "Message";

	double[] m_Xstarting = new double[1000];
	double[] m_Ystarting = new double[1000];

        for(int i = 0; i < m_NumPoints; i++) {
            m_Xstarting[i] = i;
	    m_Ystarting[i] = 0;   // initializing the Y values of the points
	    //
            //m_Y[i] = (int)((200D * Math.sin(0.10000000000000001D * (double)i) * Math.sin(0.10000000000000001D * (double)i)) / (1.0D + (double)(i - 200) * 0.001D * (double)(i - 200)));
        }

	m_Xs.add(m_Xstarting);
	m_Ys.add(m_Ystarting);
    }

    public void run()
    {
        setBackground(Color.blue);
        do
        {
            if(m_bInvalid)
            {
                repaint();
                m_bInvalid = false;
            }
            try
            {
                Thread.sleep(1000L);
            }
            catch(InterruptedException interruptedexception) { }
        } while(true);
    }

    // parse(string to parse, array to put parse values in, delimiter)
    //
    private void parse(String a, String[] b, char c) {
	System.out.println("Parsing: "+a);
        int n=0;            
	for (int i=0;i<a.length();i++) {
	    if ((a.charAt(i)==c)&&(a.length()>1)) {
		b[n++]=a.substring(0,i);
		a=a.substring(i+1);
		i=-1;
	    }
	}    
    }    

    public void updateGraphFromSlider() {
	SetParam((double)jSlider[0].getValue()/1000,(double)jSlider[1].getValue()/1000,(double)jSlider[2].getValue()/1000,(double)jSlider[3].getValue()/1000,(double)jSlider[4].getValue()/1000,(double)jSlider[5].getValue()/1000);
	updateValueLabels((double)jSlider[0].getValue()/1000,(double)jSlider[1].getValue()/1000,(double)jSlider[2].getValue()/1000,(double)jSlider[3].getValue()/1000,(double)jSlider[4].getValue()/1000,(double)jSlider[5].getValue()/1000);
    }

    public javax.swing.JComponent getLegend() {
	//JPanel ret = new javax.swing.JPanel(new GridLayout(10,0));

	JPanel ret = new javax.swing.JPanel();
	GridBagLayout gridbag = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	ret.setLayout(gridbag);
	c.fill = GridBagConstraints.VERTICAL;
	
	JLabel leglabel = new JLabel("Legend");
	c.gridx = 0; c.gridy = 0;
	gridbag.setConstraints(leglabel, c);
	ret.add(leglabel);
	//ret.add(new JLabel("Legend"));

	boolean noLegend = false;

        try{
	    // we want to create a Vector of JLabels for the Legend

	    // get the regular Equation labels --------------------------------------
	    //
	    URL addr=new URL(this.getCodeBase().getProtocol(), this.getCodeBase().getHost(), this.getCodeBase().getPort(), this.getCodeBase().getPath()+"Equations.txt");
	    DataInputStream din = new DataInputStream(addr.openStream());
	    int i=isNumber(din.readLine());

	    while ((i!=eqNum)||(i==-1)) {
		i=isNumber(din.readLine());
	    }    
	    String regline1 = din.readLine();
	    String regline2 = din.readLine();

	    Vector equations = new Vector();
	    while ( ((i!=(eqNum+1))||(i==-1)) && (din.available()>0)) {
		String toadd = din.readLine();
		i = isNumber(toadd);
		equations.add(toadd);
	    }
	    int last_element_index = equations.size()-1;
	    // If it's at the end of the file, take the last value added to the array
	    if (din.available()>0) {
		last_element_index--;
	    }
	    Vector LegendLabels = new Vector();
	    for (int graphnum = 0; graphnum <= last_element_index; graphnum++) {
		JLabel newLabel = new JLabel("---: "+(String)equations.elementAt(graphnum));
		newLabel.setForeground(LineColors.getColor(graphnum)); 		
		LegendLabels.add(newLabel);
	    }
	    System.out.println("LegendLabels size is now: " + LegendLabels.size());

	    // use any custom Legend labels -----------------------------------------
	    //
	    URL addr2=new URL(this.getCodeBase().getProtocol(), this.getCodeBase().getHost(), this.getCodeBase().getPort(), this.getCodeBase().getPath()+"Params.txt");
	    DataInputStream din2 = new DataInputStream(addr2.openStream());
	    int i2=isNumber(din2.readLine());
	    while ((i2!=eqNum)||(i2==-1)) i2=isNumber(din2.readLine());
	    for (int b=0;b<6;b++) params[b]=din2.readLine();
	    xAxisImgName=din2.readLine().substring(13);System.out.println(xAxisImgName);
	    yAxisImgName=din2.readLine().substring(13);System.out.println(yAxisImgName);

	    while ( ((i2!=(eqNum+1))||(i2==-1)) && (din2.available()>0)) {
		String toadd = din2.readLine();
		i2 = isNumber(toadd);

		System.out.println("To add: [" + toadd + "]");
		
		if (toadd.length() > 1) {   // so it's not "3" for instance

		    System.out.println("Comparing [" + toadd.substring(0,8).toLowerCase() + "]");

		    if (toadd.substring(0,8).toLowerCase().equals("nolegend")) {
			noLegend = true;
		    } else {
			String imgname = toadd.substring(10);
			String whichY = toadd.substring(1,2);
			int whichYint = Integer.parseInt(whichY);
			whichYint--;   // so y1 is equation 0
			
			JLabel newLabel = new JLabel("---: ");
			newLabel.setForeground(LineColors.getColor(whichYint)); 		
			Image img = this.getImage(getClass().getResource(imgname));
			JPanel graphdesc = new JPanel();
			//graphdesc.setLayout(new GridLayout(0,2));
			graphdesc.add(newLabel);
			graphdesc.add(new JLabel(new ImageIcon(img)));
			
			LegendLabels.setElementAt(graphdesc, whichYint);
		    }
		}
	    }

	    // create the Labels ---------------------------------------------------
	    //

	    for (int graphnum = 0; graphnum < LegendLabels.size(); graphnum++) {
		//ret.add((JComponent)  (LegendLabels.elementAt(graphnum)) );
		JComponent toadd = (JComponent)(LegendLabels.elementAt(graphnum));
		c.gridx = 0;
		c.gridy = graphnum + 1;
		c.anchor = GridBagConstraints.WEST;
		gridbag.setConstraints(toadd,c);
		ret.add(toadd);
	    }
        }        
        catch (Exception e) {e.printStackTrace();}

	if (noLegend) {
	    return null;
	} else {
	    return ret;    // the legend
	}
    }

    public javax.swing.JPanel getOptionsPanel()
    {
	innerPanel = new javax.swing.JPanel(new GridLayout(6,0));
        try{
	    URL addr=new URL(this.getCodeBase().getProtocol(), this.getCodeBase().getHost(), this.getCodeBase().getPort(), this.getCodeBase().getPath()+"Params.txt");
	    DataInputStream din = new DataInputStream(addr.openStream());
	    int i=isNumber(din.readLine());
	    while ((i!=eqNum)||(i==-1)) i=isNumber(din.readLine());
	    for (int b=0;b<6;b++) params[b]=din.readLine();
	    xAxisImgName=din.readLine().substring(13);System.out.println(xAxisImgName);
	    yAxisImgName=din.readLine().substring(13);System.out.println(yAxisImgName);
        }
        
        catch (Exception e) {e.printStackTrace();}
        jPanel.setBackground(Color.red);
        innerPanel.setSize(510,320);
        
        ChangeListener listener = new ChangeListener(){
            public void stateChanged(ChangeEvent event){
		System.out.println("Slider state change.");
		System.out.println("before change XMax is: [" + m_Xmax + "], XMin is: [" + m_Xmin + "]");
		updateGraphFromSlider();
		System.out.println("after change XMax is: [" + m_Xmax + "], XMin is: [" + m_Xmin + "]");
            }
        };

        	
        for (int i=0; i<jSlider.length;i++) {
            jSlider[i]=new JSuperSlider(0,10000);
            String[] temp=new String[6];

	    // parsing input from the data file
            this.parse(params[i],temp,'|');
            temp[1]=temp[1].substring(4);   // have it start reading after the "min="
	    System.out.println(temp[1]);
            temp[2]=temp[2].substring(4);   // after the "max="
	    System.out.println(temp[2]);
            temp[3]=temp[3].substring(7);   // after the "active="
	    System.out.println(temp[3]);
            temp[4]=temp[4].substring(5,temp[4].length()-1);  // read inside the "img="...""
	    System.out.println(temp[4]);

	    jSlider[i].setMaximum((int)(Double.parseDouble(temp[2])*1000));
	    System.out.println("setting Maximum:" +((int)(Double.parseDouble(temp[2])*1000)));
	    jSlider[i].setMinimum((int)(Double.parseDouble(temp[1])*1000));
	    System.out.println("setting Minimum:" +((int)(Double.parseDouble(temp[1])*1000)));

	    jSlider[i].setMinorTickSpacing((int)((Double.parseDouble(temp[2])-Double.parseDouble(temp[1]))*100)); // interval/10
	    jSlider[i].setMajorTickSpacing((int)((Double.parseDouble(temp[2])-Double.parseDouble(temp[1]))*500)); //(xmax-xmin)/10*5

	    labelTable[i] = new Hashtable();

	    int max=jSlider[i].getMaximum()/1000; 
	    System.out.println("small max ="+max);
	    int min=jSlider[i].getMinimum()/1000; 
	    System.out.println("small min ="+min);

	    for (int t=min;t<=max;t++){
		System.out.println("Setting label: t="+t+" and value on slider="+(t*1000));
                labelTable[i].put( new Integer( t*1000 ), new JLabel(Integer.toString(t)) );
	    }

	    jSlider[i].setLabelTable(labelTable[i]);
	    jSlider[i].setPaintLabels(true);
	    System.out.println("Adding a change listener");
	    jSlider[i].addChangeListener(listener);

	    try{
		if (!(temp[4].equals(""))) {
		    System.out.println("getting image: " + getCodeBase() + temp[4]);
		    System.out.println("temp[4]: |" + temp[4]+ "|");
		    jSlider[i].setImage(this.getImage(getCodeBase(), temp[4]));
		}
		//this.m_PanelA.xAxisImg=this.getImage(getCodeBase(), getClass().getResource(xAxisImgName));
		this.m_PanelA.xAxisImg=this.getImage(getClass().getResource(xAxisImgName));
		//this.m_PanelA.yAxisImg=this.getImage(getCodeBase(), yAxisImgName);
		this.m_PanelA.yAxisImg=this.getImage(getClass().getResource(yAxisImgName));
	    }
	    catch (Exception e) {e.printStackTrace();}

	    jSlider[i].setVisible(false);

	    if (!(temp[4].equals(""))) {
		jSlider[i].setImageVisible(false);
	    }
	    if (temp[3].equals("true")) {
		System.out.println("setting jSlider[" + i + " visible: " + temp[3]);
		jSlider[i].setVisible(true);
		jSlider[i].setImageVisible(true);
	    }

	    //innerPanel.add(jSlider[i].getContainer());

	    JPanel sliderContainer = jSlider[i].getContainer();

	    // Don't do the whole labels thing if the bar isn't visible
	    if (temp[3].equals("true")) {
		valueLabels[i] = new JTextField((new Double((double)jSlider[i].getValue()/1000)).toString(),4);   // initialize the right value here
		sliderContainer.add(valueLabels[i], BorderLayout.EAST);
	    }

	    innerPanel.add(sliderContainer);

	    jPanel.setLayout(new BorderLayout());
	    jPanel.add(innerPanel,BorderLayout.CENTER);		
	}
	jPanel.resize(510,220);
	return jPanel;
    }
    
    public static final JTextField[] valueLabels = new JTextField[6];

    public void updateValueLabels(double p1, double p2, double p3, double p4, double p5, double p6){
	if (valueLabels[0] != null) { valueLabels[0].setText((new Double(p1)).toString()); }
	if (valueLabels[1] != null) { valueLabels[1].setText((new Double(p2)).toString()); }
	if (valueLabels[2] != null) { valueLabels[2].setText((new Double(p3)).toString()); }
	if (valueLabels[3] != null) { valueLabels[3].setText((new Double(p4)).toString()); }
	if (valueLabels[4] != null) { valueLabels[4].setText((new Double(p5)).toString()); }
	if (valueLabels[5] != null) { valueLabels[5].setText((new Double(p6)).toString()); }
    }

    public void SetParam(double p1, double p2, double p3, double p4, double p5, double p6){
	if (this.getAppletContext().getApplet("Calca") != null) {
	    if (fromZoom) {
		System.out.println("It's reading something different between " + m_Xmin + "," + m_Xmax + ", and " + start_value);
		((Calca)this.getAppletContext().getApplet("Calca")).setParam(p1,p2,p3,p4,p5,p6,m_Xmin,m_Xmax);
	    } else {
		// New x values have not been defined yet.
		((Calca)this.getAppletContext().getApplet("Calca")).setParam(p1,p2,p3,p4,p5,p6);
	    }
	}
    }
    
    public int isNumber(String str) {
        try {
            int i=Integer.parseInt(str); 
            return i;
        }
        catch(Exception e) {
	    return -1;
	}
    }  

    java.awt.event.MouseAdapter mListener = new java.awt.event.MouseAdapter() {
        public void mousePressed(java.awt.event.MouseEvent evt) {
	    System.out.println("Mouse Press");

	    if ((evt.getButton()==1)&&(evt.getClickCount()>=2)) {
		if (evt.isControlDown()) {zoomXIn();System.out.println("Zooming x in");}
		else if (evt.isShiftDown()) {zoomYIn();System.out.println("Zooming y in");}
		else zoomIn();
	    }
	    else if (evt.getButton()==3) {
		System.out.println(evt.getModifiers());
		if (evt.isControlDown()) {zoomXOut();System.out.println("ZOOMING X OUT");}
		else if (evt.isShiftDown()) {zoomYOut();System.out.println("ZOOMING Y OUT");}
		else zoomOut();
	    }
	    else if (evt.getButton()==2) {restoreDefaults();repaint();}
	}
    };

    public boolean fromZoom = false;   // this variable isn't used yet. (it's from EqEditor, might be useful later)

    public void restoreDefaults() {
	m_Xmin = m_Xmin_orig;
	m_Xmax = m_Xmax_orig;
	m_Ymin = m_Ymin_orig;
	m_Ymax = m_Ymax_orig;
	updateGraphFromSlider();
	repaint();
    }

    public void zoomIn(){
	System.out.println("Zoom In");
        fromZoom=true;        
	m_Xmax = m_Xmax / 2;
	m_Xmin = m_Xmin / 2;
	m_Ymax = m_Ymax / 2;
	m_Ymin = m_Ymin / 2;
	updateGraphFromSlider();
        repaint();
    }  

    public void zoomOut() {
	System.out.println("Zoom Out");
        fromZoom=true;
	m_Xmax = m_Xmax * 2;
	m_Xmin = m_Xmin * 2;
	m_Ymax = m_Ymax * 2;
	m_Ymin = m_Ymin * 2;
	updateGraphFromSlider();
        repaint();
    }  
    
    public void zoomXIn() {
	System.out.println("Zoom X In");
        fromZoom=true;
	m_Xmax = m_Xmax / 2;
	m_Xmin = m_Xmin / 2;
	updateGraphFromSlider();
        repaint();
    }  

    public void zoomXOut() {
	System.out.println("Zoom X Out");
        fromZoom=true;
	m_Xmax = m_Xmax * 2;
	m_Xmin = m_Xmin * 2;
	updateGraphFromSlider();
        repaint();
    }  

    public void zoomYIn() {
	System.out.println("Zoom Y In");
        fromZoom=true;
	m_Ymax = m_Ymax / 2;
	m_Ymin = m_Ymin / 2;
	updateGraphFromSlider();
        repaint();
    }  

    public void zoomYOut() {
	System.out.println("Zoom Y Out");
        fromZoom=true;
	m_Ymax = m_Ymax * 2;
	m_Ymin = m_Ymin * 2;
	updateGraphFromSlider();
        repaint();
    }    
}
